C
C    Copyright (C) 2009 Anders Aspegren Søndergaard <andersas@gmail.com>
C    -------------------------------------------------------------------

C    This file is part of Wavlib.

C    Wavlib is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.

C    Wavlib is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.

C    You should have received a copy of the GNU General Public License
C    along with Wavlib. If not, see <http://www.gnu.org/licenses/>.


C       Program to distort a wav file.
C       It does this by taking the cosinus of
C       all samples...

        PROGRAM DISTOR
        IMPLICIT NONE

        INTEGER CHNLS,RATE,BPS
        INTEGER I, C(10), N, J
        INTEGER FLAG
        LOGICAL LFLAG
        INTEGER SAM

        INTEGER WAVIFO
        INTEGER OPENW
        LOGICAL MKWAV
        INTEGER READW,WRITEW

C       512 samples per bucket, max 10 channels
        REAL BUCKET(512,10)
        REAL PI

        PI = 3.14159265358979

C       Open file and a few sanity checks:        
        FLAG = OPENW(10,'test.wav')
        IF (FLAG .NE. 0) THEN
                WRITE (*,*) 'Error opening test.wav'
                STOP
        ENDIF

        CHNLS = WAVIFO(10,'Channels')
        RATE = WAVIFO(10,'Samplerate')
        BPS = WAVIFO(10,'BitsPerSample')

        IF (CHNLS .GT. 10) THEN
                WRITE(*,*) 'Too many channels'
                CALL CLOSEW(10)
                STOP
        ENDIF

C       Make an empty wavefile:
        LFLAG = MKWAV(11,'output.wav',CHNLS,RATE,BPS)
        IF (.NOT. LFLAG) THEN
                WRITE(*,*) 'Could not create output.wav'
                CALL CLOSEW(10)
                STOP
        ENDIF


C       Channel array for readw:
        DO 10 I = 1,10
                C(I) = I
  10    CONTINUE
        
        I = 1

C       Read samples from test.wav, distort the samples
C       and write them to output.wav:
  30    SAM = READW(10,CHNLS,C,I,512,BUCKET)
        IF (SAM .GT. 0) THEN
                DO 20 N = 1, CHNLS
                   DO 21 J = 1, 512
                        BUCKET(J,N) = BUCKET(J,N)**2
  21               CONTINUE
  20            CONTINUE
                FLAG = WRITEW(11, CHNLS, C,I,SAM,BUCKET)
                IF (FLAG .NE. 0) THEN
                        WRITE(*,*) 'Could not write sample'
                        CALL CLOSEW(10)
                        CALL CLOSEW(20)
                        STOP
                ENDIF
                I = I + SAM
                GOTO 30
        ENDIF

        CALL CLOSEW(10)
        CALL CLOSEW(11)

        WRITE(*,*) 'Successfully wrote output.wav'

        STOP
        END
        
