C
C    Copyright (C) 2009 Anders Aspegren Søndergaard <andersas@gmail.com>
C    -------------------------------------------------------------------

C    This file is part of Wavlib.

C    Wavlib is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.

C    Wavlib is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.

C    You should have received a copy of the GNU General Public License
C    along with Wavlib. If not, see <http://www.gnu.org/licenses/>.


C       Produce a 2-track wave file
C       with a sine tone in each, with a 4 hz difference.
C       The amplitude of each channel varies with a 
C       frequency of 1 hz and are phase-shifted 90 degrees.
C
C       Hear the resulting "swing.wav" with headphones,
C       and you'll feel a tone moving around your head...


        PROGRAM SWING
        IMPLICIT NONE

        INTEGER CHANLS, RATE, BPS, I
        REAL SECS
        PARAMETER ( RATE = 44100 )
C       The tone should last for 15 seconds:
        PARAMETER ( SECS = 15.0 )
        REAL T, PI
C       Two channels to write:
        REAL TOFILE(1,2)
        INTEGER STAT
        INTEGER C(2)

        LOGICAL MKWAV
        INTEGER WRITEW

        CHANLS = 2
        BPS = 16

C       Make an empty wav file
        IF (.NOT. MKWAV(10,'output.wav', CHANLS, RATE, BPS)) THEN
                WRITE (*,*) 'Error: file "output.wav" already exist.'
                STOP
        ENDIF

        PI = 3.141592653589793
        C(1) = 1
        C(2) = 2
        T = 0.0
        DO 10 I = 1, INT(SECS*RATE)
                T = REAL(I) / REAL(RATE)
                TOFILE(1,1) = SIN(T)*SIN(T*440*2*PI)
                TOFILE(1,2) = SIN(T+PI/2)*SIN(T*444*2*PI)
                STAT = WRITEW(10,2,C,I,1,TOFILE)
                IF (STAT .NE. 0) THEN
                        WRITE (*,*) 'Error writing file, status ', STAT
                        GOTO 20
                ENDIF
   10   CONTINUE

   20   CALL CLOSEW(10)

        WRITE(*,*) 'Successfully wrote output.wav.'

        STOP
        END
