C
C    Copyright (C) 2009 Anders Aspegren Søndergaard <andersas@gmail.com>
C    -------------------------------------------------------------------

C    This file is part of Wavlib.

C    Wavlib is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.

C    Wavlib is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.

C    You should have received a copy of the GNU General Public License
C    along with Wavlib. If not, see <http://www.gnu.org/licenses/>.


C     Get string at position POS of length SLEN
C     from the file with unit number U.
C     Put the string in STR. Return .TRUE. on success
C     and .FALSE. on error (eg end of file)
      LOGICAL FUNCTION GETSTR(STR, U,POS,SLEN)
        IMPLICIT NONE
        INTEGER U, POS, SLEN, RECRD, BUFN, RDLEN
        INTEGER I, IDX, J, FLEN
        CHARACTER STR(*)
        
        INCLUDE "../../common/wav.f"

        INTEGER GETREC

C       Length of file:
        FLEN = DESCR(DESLEN,U)

C       If the string requested exceeds the file length or
C       invalid arguments were given
        IF (FLEN .LT. POS+SLEN-1 .OR. POS .LE. 0 .OR. SLEN .LE. 0) THEN
C               Fill string with zeros and return false.
                DO 5 I = 1,SLEN
                    STR(I) = CHAR(0)
   5            CONTINUE
                GETSTR = .FALSE.
                RETURN
        ENDIF

C       Find out what record to read from, and get the
C       corrosponding buffer
        RECRD = (POS - 1) / BUFLEN + 1 
        BUFN = GETREC(U,RECRD)

C       IDX gives index of the start of the string in the buffer:
        IDX = MOD(POS - 1, BUFLEN) + 1
C       Copy SLEN bytes from buffer, unless
C       the buffer is too short.
        RDLEN = MIN(SLEN, BUFLEN - IDX + 1)
C       I is index of first unwritten char of STR.
        I = 1

   10   DO 15 J = 0, RDLEN-1
           STR(I+J) = BUF(IDX+J,BUFN)
   15   CONTINUE

        IF (RDLEN + I - 1 .LT. SLEN) THEN
C         Not all of the string was contained in the buffer.
C         Get buffer of next record and continue
          RECRD = RECRD + 1
          BUFN = GETREC(U,RECRD)
          IDX = 1
          I = I + RDLEN
          RDLEN = MIN(SLEN - I + 1, BUFLEN - IDX + 1)
          GOTO 10
        ENDIF

C       String is copied from the buffers,
        GETSTR = .TRUE.
        RETURN
      END 
