C
C    Copyright (C) 2009 Anders Aspegren Søndergaard <andersas@gmail.com>
C    -------------------------------------------------------------------

C    This file is part of Wavlib.

C    Wavlib is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.

C    Wavlib is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.

C    You should have received a copy of the GNU General Public License
C    along with Wavlib. If not, see <http://www.gnu.org/licenses/>.


C      Load a file record into a buffer and return the
C      buffer number. If an error occurs reading file,
C      program execution stops.
       INTEGER FUNCTION LOADRC(U,RECRD)
         IMPLICIT NONE
         INTEGER U, RECRD, BUFN, LEAST, LAST, LENGTH
         INTEGER I
         CHARACTER FILL
         INCLUDE "../../common/wav.f"

C        Determine what buffer to discard by choosing
C        the least used buffer
         LEAST = USED(1)
         BUFN = 1
         DO 10 I = 2, NBUFS
               IF (USED(I) .LT. LEAST) THEN
                        LEAST = USED(I)
                        BUFN = I
               ENDIF
   10    CONTINUE

C        Dispose the chosen buffer
         CALL DEPORT(BUFN)

C        read data from file and update metadata
C        If we're at end of file, only read
C        up to the end.

         LENGTH = DESCR(DESLEN,U)
       
C        If we're requested to retrieve data in the file:
         IF ((RECRD-1)*BUFLEN .LT. LENGTH) THEN
           LAST = BUFLEN
C          If the file ends in this record, only read up to file end
           IF (RECRD*BUFLEN .GT. LENGTH) LAST = MOD(LENGTH,BUFLEN)

           READ(UNIT=U,REC=RECRD) (BUF(I,BUFN),I=1,LAST)

         ELSE
            LAST = 0
         ENDIF


C        If we reached end of file, fill the rest of the buffer
C        with zeros. Note that 8-bit files have 127 as zero.

         IF (LAST .NE. BUFLEN) THEN
             IF (DESCR(DESBPS,U) .EQ. 8) THEN
                   FILL = CHAR(127)
             ELSE
                   FILL = CHAR(0)
             ENDIF
             DO 30 I = LAST+1, BUFLEN
               BUF(I,BUFN) = FILL
   30        CONTINUE
         ENDIF

C        Update metadata
         RECORD(1,BUFN) = U
         RECORD(2,BUFN) = RECRD

C        Return the buffer number we just wrote to
         LOADRC = BUFN 
        RETURN

       END 

