C
C    Copyright (C) 2009 Anders Aspegren Søndergaard <andersas@gmail.com>
C    -------------------------------------------------------------------

C    This file is part of Wavlib.

C    Wavlib is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.

C    Wavlib is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.

C    You should have received a copy of the GNU General Public License
C    along with Wavlib. If not, see <http://www.gnu.org/licenses/>.


C     Get sample S, channel C of file U. Return .TRUE. on success,
C     .FALSE. on error. No error checking.

      LOGICAL FUNCTION GETSAM(U,SMPLE, S, C)
        IMPLICIT NONE
        INTEGER U, S, C
        INTEGER SMPLE
        INTEGER TEMP
        INTEGER POS, LENGTH,CHANLS,BITS
        LOGICAL SGNED
        INCLUDE "../../common/wav.f"
        LOGICAL GETINT

C       Bits per sample 
        BITS = DESCR(DESBPS,U)
 
        IF (BITS .NE. 8) THEN
                SGNED = .TRUE.
        ELSE
                SGNED = .FALSE.
        ENDIF
C       One sample length
        LENGTH = BITS / 8
C       Number of channels
        CHANLS = DESCR(DESCNS,U)

        IF (C .GT. CHANLS .OR. C .LE. 0) THEN
C               Invalid chanel
                GETSAM = .FALSE.
                RETURN
        ENDIF

C       Position of the desired sample
        POS = DESCR(DESDAT,U)+8+LENGTH*CHANLS*((S+C-1)-1)

        GETSAM = GETINT(TEMP, U, POS, LENGTH, SGNED)
        IF (.NOT. GETSAM) RETURN

        SMPLE = TEMP

        RETURN
      END


