C
C    Copyright (C) 2009 Anders Aspegren Søndergaard <andersas@gmail.com>
C    -------------------------------------------------------------------

C    This file is part of Wavlib.

C    Wavlib is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.

C    Wavlib is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.

C    You should have received a copy of the GNU General Public License
C    along with Wavlib. If not, see <http://www.gnu.org/licenses/>.


C     Get 'fmt ' and 'data' subchunks of open RIFF WAVE file U.      
C     If data is the last subchunk, set DATLST true, false otherwise
C     Return true on success, false on error (eg missing
C     fmt and data subchunks, sudden file ending etc)
      LOGICAL FUNCTION GTCNKS(U, DAT,DATLEN,FORMT,FMTLEN,DATLST)
        IMPLICIT NONE
        INTEGER U,DAT,DATLEN,FORMT,FMTLEN
        LOGICAL DATLST
        INTEGER IDX, CNKLEN, FLEN
        CHARACTER*4 SUBCHK
        INCLUDE "../../common/wav.f"
        LOGICAL GETSTR, GETINT

        FLEN = DESCR(DESLEN,U)

        DAT = -1
        FORMT = -1
C       RIFF WAVE header is 12 bytes long,
C       so the first subchunk index is
        IDX = 13

  10    IF (.NOT. GETSTR(SUBCHK, U, IDX, 4)) GOTO 99
        IF (.NOT. GETINT(CNKLEN, U, IDX+4, 4, .TRUE.)) GOTO 99
        IF (CNKLEN .LT. 0) GOTO 99
        IF (SUBCHK .EQ. 'fmt ') THEN
C               Multiple format subchunks?
                IF (FORMT .GE. 0) GOTO 99
                FORMT = IDX
                FMTLEN = CNKLEN
        ELSEIF (SUBCHK .EQ. 'data') THEN
C               Multiple data subchunks?
                IF (DAT .GE. 0) GOTO 99
                DAT = IDX
                DATLEN = CNKLEN
        ENDIF

        IDX = IDX + 8 + CNKLEN
C       If there are more subchunks
        IF (IDX .LT. FLEN) GOTO 10

C       No more chunks, check if we got both
C       fmt and data, and see if data is the last

        IF (DAT .EQ. -1 .OR. FORMT .EQ. -1) GOTO 99

        IF (DAT + 8 + DATLEN .EQ. FLEN) THEN
                DATLST = .TRUE.
        ELSE
                DATLST = .FALSE.
        ENDIF

        GTCNKS = .TRUE.
        RETURN
  99    GTCNKS = .FALSE.
        RETURN
      END


