C
C    Copyright (C) 2009 Anders Aspegren Søndergaard <andersas@gmail.com>
C    -------------------------------------------------------------------

C    This file is part of Wavlib.

C    Wavlib is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.

C    Wavlib is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.

C    You should have received a copy of the GNU General Public License
C    along with Wavlib. If not, see <http://www.gnu.org/licenses/>.


C     Subroutine to update file and subchunk lengths
C     if they've been changed.

      SUBROUTINE UPDLEN(U)
        IMPLICIT NONE
        INTEGER U
        INCLUDE "../../common/wav.f"

        IF (CHGWLN(U)) THEN
C           Write the current file length to
C           the header at position 5-8 (minus header size):
            CALL SETINT(DESCR(DESLEN,U)-8,U,5,4)
            CHGWLN(U) = .FALSE.
C           This really should not change the file length,
C           so we're not going to test again.
        ENDIF
        
        IF (CHGSAM(U)) THEN
C           Write the current datasubchunk length to
C           the data subchunkheader, position 5-8:
            CALL SETINT(DESCR(DESDLN,U),U,DESCR(DESDAT,U)+4,4)
            CHGSAM(U) = .FALSE.
        ENDIF

      END


