C
C    Copyright (C) 2009 Anders Aspegren Søndergaard <andersas@gmail.com>
C    -------------------------------------------------------------------

C    This file is part of Wavlib.

C    Wavlib is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.

C    Wavlib is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.

C    You should have received a copy of the GNU General Public License
C    along with Wavlib. If not, see <http://www.gnu.org/licenses/>.


C     Function to find maximum integer we can support.
C     Either the the maximum integer the machine supports,
C     or if it's larger than than the maximum size the RIFF Wave file
C     format supports, return that size instead (4GB + 8 byte)

      INTEGER FUNCTION MAXWAV()
        INTEGER MAXNT, BITS
        DATA MAXNT / -1 /
        SAVE MAXNT

C       See if this has been calculated before
        IF (MAXNT .GE. 0) THEN
                MAXWAV = MAXNT
                RETURN
        ENDIF

C       Count the number of times we can rightshift
C       1 by 1 bit before getting 0:
        BITS = 1
  10    IF (ISHFT(1,BITS) .NE. 0) THEN
                BITS = BITS + 1
                GOTO 10
        ENDIF

C       In twos complement, this is the maximum integer
C       we can represent:
        MAXNT = ISHFT(1,BITS-1) - 1

C       If an INTEGER can address an entire 4 GB wav file,
C       Note that we need at least 34 bits to represent
C       2**32-1 + 8 in 2's complement.
        IF (BITS .GT. 33) THEN
C               We need to build 2**32 - 1 + 8. Not all compilers
C               will allow us to just write 4294967303
C               as an integer constant.
                MAXNT = 2
                MAXNT = MAXNT**32
                MAXNT = MAXNT + 7
        ENDIF

        MAXWAV = MAXNT

        RETURN
      END


