C
C    Copyright (C) 2009 Anders Aspegren Søndergaard <andersas@gmail.com>
C    -------------------------------------------------------------------

C    This file is part of Wavlib.

C    Wavlib is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.

C    Wavlib is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.

C    You should have received a copy of the GNU General Public License
C    along with Wavlib. If not, see <http://www.gnu.org/licenses/>.


C     This function duplicates READW, except it returns the
C     actual raw sample, instead of a REAL in the interval [-1.0;1.0].
C     Notice that 8 bit .wav files use unsigned values in the range
C     0-255, all other use ordinary signed integers. Sign extention
C     is performed before returning.

C     Returns the number of samples per channel read
C     (eg 0 on error), or -1 if the file is not opened
      INTEGER FUNCTION RDSAM(U, NCHNLS, CHANEL, START, NSMPLS, SMPLE)
        IMPLICIT NONE
        INTEGER U, START, NSMPLS, NCHNLS
        INTEGER CHANEL(NCHNLS)
        INTEGER SMPLE(NSMPLS, NCHNLS)
        INTEGER I,N,IDX
        INCLUDE "../../common/wav.f"
        LOGICAL GETSAM

C       Stop if file is not opened
        IF (DESCR(DESLEN,U) .LE. 0) THEN
                RDSAM = -1
                RETURN
        ENDIF

        DO 10 I = 1, NCHNLS
         IF (CHANEL(I) .LE. 0 .OR. CHANEL(I) .GT. DESCR(DESCNS,U)) THEN
C               Invalid channel request
                GOTO 99
         ENDIF
  10    CONTINUE

C       If we start after the last sample
        IF (START .GT. DESCR(DESSAM,U)) GOTO 99

C       Read the actual samples. If we reach end of file
C       before SMPLE is filled up, stop and return
C       the actual samples (per channel) returned.

        RDSAM = 0
        IDX = 1
        DO 30 I = START, MIN(START + NSMPLS - 1,DESCR(DESSAM,U))
               DO 20 N = 1,NCHNLS
                 IF (.NOT. GETSAM(U, SMPLE(IDX,N), I,CHANEL(N))) THEN
                        GOTO 40
                 ENDIF
  20           CONTINUE
               IDX = IDX + 1
               RDSAM = RDSAM + 1
  30    CONTINUE
  
  40  RETURN
  99  RDSAM = 0
      RETURN
      END

