C
C    Copyright (C) 2009 Anders Aspegren Søndergaard <andersas@gmail.com>
C    -------------------------------------------------------------------

C    This file is part of Wavlib.

C    Wavlib is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.

C    Wavlib is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.

C    You should have received a copy of the GNU General Public License
C    along with Wavlib. If not, see <http://www.gnu.org/licenses/>.


C     Sets the header information about the wave file U,
C     eg. sample rate. It only sets header info, it does
C     not change the samples in any way
C     Returns true on success, false on error.

      LOGICAL FUNCTION SETIFO(U,PROP,VALUE)
        INTEGER U, VALUE
        CHARACTER*(*) PROP
        INTEGER BYTERT, BLKALN, CHNS, RATE, BPS, SAM, LNGTH
        INTEGER OFFSET
        INCLUDE "../../common/wav.f"

        SETIFO = .FALSE.

C       Check if the file is open
        IF (DESCR(DESLEN,U) .LE. 0) THEN
          RETURN
        ENDIF
C       Check if the values are sane
        IF (VALUE .LE. 0 .OR.
     +  (VALUE .GT. 65535 .AND. PROP .NE. 'BitsPerSample')) THEN
                RETURN
        ENDIF

        RATE = DESCR(DESRTE,U)
        BPS = DESCR(DESBPS,U)
        CHNS = DESCR(DESCNS,U)
        SAM = DESCR(DESSAM,U)
        LNGTH = DESCR(DESDLN,U)

        IF (PROP .EQ. 'Channels') THEN
                CHNS = VALUE
                SETIFO = .TRUE.
        ELSEIF (PROP .EQ. 'Samplerate') THEN
                RATE = VALUE
                SETIFO = .TRUE.
        ELSEIF (PROP .EQ. 'BitsPerSample') THEN
                BPS = VALUE
C               We only support an integer amount of bytes per sample
                IF (MOD(BPS,8) .EQ. 0) THEN
                        SETIFO = .TRUE.
                ENDIF
        ENDIF

        IF (SETIFO) THEN

                BYTERT = RATE*CHNS*BPS/8
                BLKALN = CHNS*BPS/8
C       Write info to format header
                OFFSET = DESCR(DESFMT,U)
                CALL SETINT(CHNS,U,OFFSET+10,2)
                CALL SETINT(RATE,U,OFFSET+12,4)
                CALL SETINT(BYTERT,U,OFFSET+16,4)
                CALL SETINT(BLKALN,U,OFFSET+20,2)
                CALL SETINT(BPS,U,OFFSET+22,2)

                DESCR(DESRTE,U) = RATE
                DESCR(DESBPS,U) = BPS
                DESCR(DESCNS,U) = CHNS
                DESCR(DESSAM,U) = LNGTH/(CHNS*BPS/8)
        ENDIF


        RETURN
      END
